



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用Node.js实现简易MVC框架</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用Node.js实现简易MVC框架</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 18:11:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在<a href="http://www.cnblogs.com/SheilaSun/p/7271883.html" rel="external nofollow noreferrer">使用Node.js搭建静态资源服务器</a>一文中我们完成了服务器对静态资源请求的处理，但并未涉及动态请求，目前还无法根据客户端发出的不同请求而返回个性化的内容。单靠静态资源岂能撑得起这些复杂的网站应用，本文将介绍如何使用<code>Node</code>处理动态请求，以及如何搭建一个简易的 MVC 框架。因为前文已经详细介绍过静态资源请求如何响应，本文将略过所有静态部分。</p>
<h2>一个简单的示例</h2>
<p>先从一个简单示例入手，明白在 Node 中如何向客户端返回动态内容。</p>
<p>假设我们有这样的需求：</p>
<ol><li>当用户访问 <code>/actors </code>时返回男演员列表页</li>
<li>当用户访问 <code>/actresses </code>时返回女演员列表</li></ol>
<p>可以用以下的代码完成功能：</p>
<pre class="prettyprint linenums"><code>const http = require('http');<br />
const url = require('url');

http.createServer((req, res) =&gt; {<br />
    const pathName = url.parse(req.url).pathname;<br />
    if (['/actors', '/actresses'].includes(pathName)) {<br />
        res.writeHead(200, {<br />
            'Content-Type': 'text/html'<br />
        });<br />
        const actors = ['Leonardo DiCaprio', 'Brad Pitt', 'Johnny Depp'];<br />
        const actresses = ['Jennifer Aniston', 'Scarlett Johansson', 'Kate Winslet'];<br />
        let lists = [];<br />
        if (pathName === '/actors') {<br />
            lists = actors;<br />
        } else {<br />
            lists = actresses;<br />
        }

        const content = lists.reduce((template, item, index) =&gt; {<br />
            return template + `&lt;p&gt;No.${index+1} ${item}&lt;/p&gt;`;<br />
        }, `&lt;h1&gt;${pathName.slice(1)}&lt;/h1&gt;`);<br />
        res.end(content);<br />
    } else {<br />
        res.writeHead(404);<br />
        res.end('&lt;h1&gt;Requested page not found.&lt;/h1&gt;')<br />
    }<br />
}).listen(9527);<br />
</code></pre>
<p>上面代码的核心是路由匹配，当请求抵达时，检查是否有对应其路径的逻辑处理，当请求匹配不上任何路由时，返回 404。匹配成功时处理相应的逻辑。</p>
<p><img referrerpolicy="no-referrer"src="http://ot9sgcky1.bkt.clouddn.com/image/nodejs-mvc-framework/Screen%20Shot%202017-08-05%20at%205.20.48%20PM.png"></p>
<p>上面的代码显然并不通用，而且在仅有两种路由匹配候选项（且还未区分请求方法），以及尚未使用数据库以及模板文件的前提下，代码都已经有些纠结了。因此接下来我们将搭建一个简易的MVC框架，使数据、模型、表现分离开来，各司其职。</p>
<h2>搭建简易MVC框架</h2>
<p>MVC 分别指的是：</p>
<ol><li>M: Model （数据)</li>
<li>V: View  （表现）</li>
<li>C: Controller	（逻辑）</li></ol>
<p>在 Node 中，MVC 架构下处理请求的过程如下：</p>
<ol><li>请求抵达服务端</li>
<li>服务端将请求交由路由处理</li>
<li>路由通过路径匹配，将请求导向对应的 controller</li>
<li>controller 收到请求，向 model 索要数据</li>
<li>model 给 controller 返回其所需数据</li>
<li>controller 可能需要对收到的数据做一些再加工</li>
<li>controller 将处理好的数据交给 view</li>
<li>view 根据数据和模板生成响应内容</li>
<li>服务端将此内容返回客户端</li></ol>
<p>以此为依据，我们需要准备以下模块：</p>
<ol><li>server: 监听和响应请求</li>
<li>router: 将请求交由正确的controller处理</li>
<li>controllers: 执行业务逻辑，从 model 中取出数据，传递给 view</li>
<li>model: 提供数据</li>
<li>view: 提供 html</li></ol>
<h3>代码结构</h3>
<p>创建如下目录：</p>
<pre class="prettyprint linenums"><code>-- server.js<br />
-- lib<br />
	-- router.js<br />
-- views<br />
-- controllers<br />
-- models<br />
</code></pre>
<h3>server</h3>
<p>创建 <strong>server.js</strong> 文件：</p>
<pre class="prettyprint linenums"><code>const http = require('http');<br />
const router = require('./lib/router')();

router.get('/actors', (req, res) =&gt; {<br />
    res.end('Leonardo DiCaprio, Brad Pitt, Johnny Depp');<br />
});

http.createServer(router).listen(9527, err =&gt; {<br />
    if (err) {<br />
        console.error(err);<br />
        console.info('Failed to start server');<br />
    } else {<br />
        console.info(`Server started`);<br />
    }<br />
});<br />
</code></pre>
<p>先不管这个文件里的细节，<code>router</code>是下面将要完成的模块，这里先引入，请求抵达后即交由它处理。</p>
<h3>router 模块</h3>
<p>router模块其实只需完成一件事，将请求导向正确的controller处理，理想中它可以这样使用：</p>
<pre class="prettyprint linenums"><code>const router = require('./lib/router')();<br />
const actorsController = require('./controllers/actors');

router.use((req, res, next) =&gt; {<br />
	console.info('New request arrived');<br />
	next()<br />
});

router.get('/actors', (req, res) =&gt; {<br />
    actorsController.fetchList();<br />
});

router.post('/actors/:name', (req, res) =&gt; {<br />
    actorsController.createNewActor();<br />
});<br />
</code></pre>
<p>总的来说，我们希望它同时支持路由中间件和非中间件，请求抵达后会由 router 交给匹配上的中间件们处理。中间件是一个可访问请求对象和响应对象的函数，在中间件内可以做的事情包括：</p>
<ol><li>执行任何代码，比如添加日志和处理错误等</li>
<li>修改请求 (req) 和响应对象 (res)，比如从 req.url 获取查询参数并赋值到 req.query</li>
<li>结束响应</li>
<li>调用下一个中间件 (next)</li></ol>
<blockquote><p>Note:</p>
<p>需要注意的是，如果在某个中间件内既没有终结响应，也没有调用 next 方法将控制权交给下一个中间件， 则请求就会挂起</p></blockquote>
<p>__非路由中间件__通过以下方式添加，匹配所有请求：</p>
<pre class="prettyprint linenums"><code>router.use(fn);<br />
</code></pre>
<p>比如上面的例子：</p>
<pre class="prettyprint linenums"><code>router.use((req, res, next) =&gt; {<br />
	console.info('New request arrived');<br />
	next()<br />
});<br />
</code></pre>
<p>__路由中间件__通过以下方式添加，以 请求方法和路径精确匹配：</p>
<pre class="prettyprint linenums"><code>router.HTTP_METHOD(path, fn)<br />
</code></pre>
<p>梳理好了之后先写出框架：</p>
<p><strong>/lib/router.js</strong></p>
<pre class="prettyprint linenums"><code>const METHODS = ['GET', 'POST', 'PUT', 'DELETE', 'HEAD', 'OPTIONS'];

module.exports = () =&gt; {<br />
    const routes = [];

    const router = (req, res) =&gt; {

    };

    router.use = (fn) =&gt; {<br />
        routes.push({<br />
            method: null,<br />
            path: null,<br />
            handler: fn<br />
        });<br />
    };

    METHODS.forEach(item =&gt; {<br />
        const method = item.toLowerCase();<br />
        router[method] = (path, fn) =&gt; {<br />
            routes.push({<br />
                method,<br />
                path,<br />
                handler: fn<br />
            });<br />
        };<br />
    });<br />
};<br />
</code></pre>
<p>以上主要是给 router 添加了 <code>use</code>、<code>get</code>、<code>post</code> 等方法，每当调用这些方法时，给 routes 添加一条 route 规则。</p>
<blockquote><p>Note:</p>
<p>Javascript 中函数是一种特殊的对象，能被调用的同时，还可以拥有属性、方法。</p></blockquote>
<p>接下来的重点在 <code>router</code> 函数，它需要做的是：</p>
<ol><li>从<code>req</code>对象中取得 method、pathname</li>
<li>依据 method、pathname 将请求与routes数组内各个 route 按它们被添加的顺序依次匹配</li>
<li>如果与某个route匹配成功，执行 route.handler，执行完后与下一个 route 匹配或结束流程 （后面详述）</li>
<li>如果匹配不成功，继续与下一个 route 匹配，重复3、4步骤</li></ol>
<pre class="prettyprint linenums"><code>    const router = (req, res) =&gt; {<br />
        const pathname = decodeURI(url.parse(req.url).pathname);<br />
        const method = req.method.toLowerCase();<br />
        let i = 0;

        const next = () =&gt; {<br />
            route = routes[i++];<br />
            if (!route) return;<br />
            const routeForAllRequest = !route.method &amp;&amp; !route.path;<br />
            if (routeForAllRequest || (route.method === method &amp;&amp; pathname === route.path)) {<br />
                route.handler(req, res, next);<br />
            } else {<br />
                next();<br />
            }<br />
        }

        next();<br />
    };<br />
</code></pre>
<p>对于非路由中间件，直接调用其 handler。对于路由中间件，只有请求方法和路径都匹配成功时，才调用其 handler。当没有匹配上的 route 时，直接与下一个route继续匹配。</p>
<p>需要注意的是，在某条 route 匹配成功的情况下，执行完其 handler 之后，还会不会再接着与下个 route 匹配，就要看开发者在其 handler 内有没有主动调用 next() 交出控制权了。</p>
<p>在__server.js__中添加一些route：</p>
<pre class="prettyprint linenums"><code>router.use((req, res, next) =&gt; {<br />
	console.info('New request arrived');<br />
	next()<br />
});

router.get('/actors', (req, res) =&gt; {<br />
    res.end('Leonardo DiCaprio, Brad Pitt, Johnny Depp');<br />
});

router.get('/actresses', (req, res) =&gt; {<br />
    res.end('Jennifer Aniston, Scarlett Johansson, Kate Winslet');<br />
});

router.use((req, res, next) =&gt; {<br />
    res.statusCode = 404;<br />
    res.end();<br />
});<br />
</code></pre>
<p>每个请求抵达时，首先打印出一条 log，接着匹配其他route。当匹配上 actors 或 actresses 的 get 请求时，直接发回演员名字，并不需要继续匹配其他 route。如果都没匹配上，返回 404。</p>
<p>在浏览器中依次访问 <code>http://localhost:9527/erwe</code>、<code>http://localhost:9527/actors</code>、<code>http://localhost:9527/actresses</code> 测试一下：</p>
<p><img referrerpolicy="no-referrer"src="http://ot9sgcky1.bkt.clouddn.com/image/nodejs-mvc-framework/Screen%20Shot%202017-08-06%20at%207.44.43%20AM.png"></p>
<p><code>network</code> 中观察到的结果符合预期，同时后台命令行中也打印出了三条 <code>New request arrived</code>语句。</p>
<p>接下来继续改进 router 模块。</p>
<p>首先添加一个 router.all 方法，调用它即意味着为所有请求方法都添加了一条 route：</p>
<pre class="prettyprint linenums"><code>    router.all = (path, fn) =&gt; {<br />
        METHODS.forEach(item =&gt; {<br />
            const method = item.toLowerCase();<br />
            router[method](path, fn);<br />
        })<br />
    };<br />
</code></pre>
<p>接着，添加错误处理。</p>
<p><strong>/lib/router.js</strong></p>
<pre class="prettyprint linenums"><code>const defaultErrorHander = (err, req, res) =&gt; {<br />
    res.statusCode = 500;<br />
    res.end();<br />
};

module.exports = (errorHander) =&gt; {<br />
    const routes = [];

    const router = (req, res) =&gt; {<br />
			...<br />
        errorHander = errorHander || defaultErrorHander;

        const next = (err) =&gt; {<br />
            if (err) return errorHander(err, req, res);<br />
            ...<br />
        }

        next();<br />
    };<br />
</code></pre>
<p><strong>server.js</strong></p>
<pre class="prettyprint linenums"><code>...<br />
const router = require('./lib/router')((err, req, res) =&gt; {<br />
    console.error(err);<br />
    res.statusCode = 500;<br />
    res.end(err.stack);<br />
});<br />
...<br />
</code></pre>
<p>默认情况下，遇到错误时会返回 500，但开发者使用 router 模块时可以传入自己的错误处理函数将其替代。</p>
<p>修改一下代码，测试是否能正确执行错误处理：</p>
<pre class="prettyprint linenums"><code>router.use((req, res, next) =&gt; {<br />
	console.info('New request arrived');<br />
	next(new Error('an error'));<br />
});<br />
</code></pre>
<p>这样任何请求都应该返回 500：</p>
<p><img referrerpolicy="no-referrer"src="http://ot9sgcky1.bkt.clouddn.com/image/nodejs-mvc-framework/Screen%20Shot%202017-08-06%20at%209.35.57%20AM.png"></p>
<p>继续，修改 route.path 与 pathname 的匹配规则。现在我们认为只有当两字符串相等时才让匹配通过，这没有考虑到 url 中包含路径参数的情况，比如：</p>
<pre class="prettyprint linenums"><code>localhost:9527/actors/Leonardo<br />
</code></pre>
<p>与</p>
<pre class="prettyprint linenums"><code>router.get('/actors/:name', someRouteHandler);<br />
</code></pre>
<p>这条route应该匹配成功才是。</p>
<p>新增一个函数用来将字符串类型的 route.path 转换成正则对象，并存入 route.pattern：</p>
<pre class="prettyprint linenums"><code>const getRoutePattern = pathname =&gt; {<br />
  pathname = '^' + pathname.replace(/(\:\w+)/g, '\(\[a-zA-Z0-9-\]\+\\s\)') + '$';<br />
  return new RegExp(pathname);<br />
};<br />
</code></pre>
<p>这样就可以匹配上带有路径参数的url了，并将这些路径参数存入 req.params 对象：</p>
<pre class="prettyprint linenums"><code>        const matchedResults = pathname.match(route.pattern);<br />
        if (route.method === method &amp;&amp; matchedResults) {<br />
            addParamsToRequest(req, route.path, matchedResults);<br />
            route.handler(req, res, next);<br />
        } else {<br />
            next();<br />
        }<br />
</code></pre>
<pre class="prettyprint linenums"><code>const addParamsToRequest = (req, routePath, matchedResults) =&gt; {<br />
    req.params = {};<br />
    let urlParameterNames = routePath.match(/:(\w+)/g);<br />
    if (urlParameterNames) {<br />
        for (let i=0; i &lt; urlParameterNames.length; i++) {<br />
            req.params[urlParameterNames[i].slice(1)] = matchedResults[i + 1];<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p>添加个 route 测试一下:</p>
<pre class="prettyprint linenums"><code>router.get('/actors/:year/:country', (req, res) =&gt; {<br />
    res.end(`year: ${req.params.year} country: ${req.params.country}`);<br />
});<br />
</code></pre>
<p>访问<code>http://localhost:9527/actors/1990/China</code>试试:</p>
<p><img referrerpolicy="no-referrer"src="http://ot9sgcky1.bkt.clouddn.com/image/nodejs-mvc-framework/Screen%20Shot%202017-08-06%20at%2011.15.46%20AM.png"></p>
<p>router 模块就写到此，至于查询参数的格式化以及获取请求主体，比较琐碎就不试验了，需要可以直接使用 <a href="https://www.npmjs.com/package/body-parser" rel="external nofollow noreferrer">bordy-parser</a> 等模块。</p>
<h3>controller</h3>
<p>现在我们已经创建好了router模块，接下来将 route handler 内的业务逻辑都转移到 controller 中去。</p>
<p>修改__server.js__，引入 controller:</p>
<pre class="prettyprint linenums"><code>...<br />
const actorsController = require('./controllers/actors');<br />
...<br />
router.get('/actors', (req, res) =&gt; {<br />
    actorsController.getList(req, res);<br />
});

router.get('/actors/:name', (req, res) =&gt; {<br />
    actorsController.getActorByName(req, res);<br />
});

router.get('/actors/:year/:country', (req, res) =&gt; {<br />
    actorsController.getActorsByYearAndCountry(req, res);<br />
});<br />
...<br />
</code></pre>
<p>新建__controllers/actors.js__:</p>
<pre class="prettyprint linenums"><code>const actorsTemplate = require('../views/actors-list');<br />
const actorsModel = require('../models/actors');

exports.getList = (req, res) =&gt; {<br />
    const data = actorsModel.getList();<br />
    const htmlStr = actorsTemplate.build(data);<br />
    res.writeHead(200, {<br />
        'Content-Type': 'text/html'<br />
    });<br />
    res.end(htmlStr);<br />
};

exports.getActorByName = (req, res) =&gt; {<br />
    const data = actorsModel.getActorByName(req.params.name);<br />
    const htmlStr = actorsTemplate.build(data);<br />
    res.writeHead(200, {<br />
        'Content-Type': 'text/html'<br />
    });<br />
    res.end(htmlStr);<br />
};

exports.getActorsByYearAndCountry = (req, res) =&gt; {<br />
    const data = actorsModel.getActorsByYearAndCountry(req.params.year, req.params.country);<br />
    const htmlStr = actorsTemplate.build(data);<br />
    res.writeHead(200, {<br />
        'Content-Type': 'text/html'<br />
    });<br />
    res.end(htmlStr);<br />
};<br />
</code></pre>
<p>在 controller 中同时引入了 view 和 model， 其充当了这二者间的粘合剂。回顾下 controller 的任务：</p>
<ol><li>controller 收到请求，向 model 索要数据</li>
<li>model 给 controller 返回其所需数据</li>
<li>controller 可能需要对收到的数据做一些再加工</li>
<li>controller 将处理好的数据交给 view</li></ol>
<p>在此 controller 中，我们将调用 model 模块的方法获取演员列表，接着将数据交给 view，交由 view 生成呈现出演员列表页的 html 字符串。最后将此字符串返回给客户端，在浏览器中呈现列表。</p>
<h3>从 model 中获取数据</h3>
<p>通常 model 是需要跟数据库交互来获取数据的，这里我们就简化一下，将数据存放在一个 json 文件中。</p>
<p><strong>/models/test-data.json</strong></p>
<pre class="prettyprint linenums"><code>[<br />
    {<br />
        &quot;name&quot;: &quot;Leonardo DiCaprio&quot;,<br />
        &quot;birth year&quot;: 1974,<br />
        &quot;country&quot;: &quot;US&quot;,<br />
        &quot;movies&quot;: [&quot;Titanic&quot;, &quot;The Revenant&quot;, &quot;Inception&quot;]<br />
    },<br />
    {<br />
        &quot;name&quot;: &quot;Brad Pitt&quot;,<br />
        &quot;birth year&quot;: 1963,<br />
        &quot;country&quot;: &quot;US&quot;,<br />
        &quot;movies&quot;: [&quot;Fight Club&quot;, &quot;Inglourious Basterd&quot;, &quot;Mr. &amp; Mrs. Smith&quot;]<br />
    },<br />
    {<br />
        &quot;name&quot;: &quot;Johnny Depp&quot;,<br />
        &quot;birth year&quot;: 1963,<br />
        &quot;country&quot;: &quot;US&quot;,<br />
        &quot;movies&quot;: [&quot;Edward Scissorhands&quot;, &quot;Black Mass&quot;, &quot;The Lone Ranger&quot;]<br />
    }<br />
]<br />
</code></pre>
<p>接着就可以在 model 中定义一些方法来访问这些数据。</p>
<p><strong>models/actors.js</strong></p>
<pre class="prettyprint linenums"><code>const actors = require('./test-data');

exports.getList = () =&gt; actors;

exports.getActorByName = (name) =&gt; actors.filter(actor =&gt; {<br />
    return actor.name == name;<br />
});

exports.getActorsByYearAndCountry = (year, country) =&gt; actors.filter(actor =&gt; {<br />
    return actor[&quot;birth year&quot;] == year &amp;&amp; actor.country == country;<br />
});<br />
</code></pre>
<h3>view</h3>
<p>当 controller 从 model 中取得想要的数据后，下一步就轮到 view 发光发热了。view 层通常都会用到模板引擎，如 dust 等。同样为了简化，这里采用简单替换模板中占位符的方式获取 html，渲染得非常有限，粗略理解过程即可。</p>
<p>创建 <strong>/views/actors-list.js</strong>:</p>
<pre class="prettyprint linenums"><code>const actorTemplate = `<br />
&lt;h1&gt;{name}&lt;/h1&gt;<br />
&lt;p&gt;&lt;em&gt;Born: &lt;/em&gt;{contry}, {year}&lt;/p&gt;<br />
&lt;ul&gt;{movies}&lt;/ul&gt;<br />
`;

exports.build = list =&gt; {<br />
    let content = '';<br />
    list.forEach(actor =&gt; {<br />
        content += actorTemplate.replace('{name}', actor.name)<br />
                    .replace('{contry}', actor.country)<br />
                    .replace('{year}', actor[&quot;birth year&quot;])<br />
                    .replace('{movies}', actor.movies.reduce((moviesHTML, movieName) =&gt; {<br />
                        return moviesHTML + `&lt;li&gt;${movieName}&lt;/li&gt;`<br />
                    }, ''));<br />
    });<br />
    return content;<br />
};<br />
</code></pre>
<p>在浏览器中测试一下：</p>
<p><img referrerpolicy="no-referrer"src="http://ot9sgcky1.bkt.clouddn.com/image/nodejs-mvc-framework/Screen%20Shot%202017-08-06%20at%201.47.35%20PM.png"></p>
<p>至此，就大功告成啦！</p>
<h2>参考</h2>
<ol><li><a href="http://www.jianshu.com/p/a5dabbf4dd66" rel="external nofollow noreferrer">Nodejs实现一个简单的服务器</a></li>
<li><a href="http://theholmesoffice.com/getting-ready-for-scalability-creating-an-mvc-framework-for-our-node-js-page/" rel="external nofollow noreferrer">Creating an MVC framework for our Node.js page - getting ready for scalability</a></li></ol>
<h2>源码</h2>
<p>戳我的 GitHub repo: <a href="https://github.com/sheila1227/node-mvc-framework" rel="external nofollow noreferrer">node-mvc-framework</a></p>
<p>博文也同步在 GitHub，欢迎讨论和指正：<a href="https://github.com/sheila1227/FE-blog/issues/2" rel="external nofollow noreferrer">使用Node.js实现简易MVC框架</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4nn7n9.html">编写我的第一个CGI代码&mdash;&mdash;python学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/49577peq.html">Web API Filter ActionFilterAttribute 使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn043x9.html">如何查询Oracle中所有用户信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlzkxe8.html">access violation at address  General protection fault</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mne2kq.html">LeetCode40 Combination Sum II</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjvlj79.html">用twisted 做一个日志收集系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k176159.html">Markdown 入门教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmod7z9.html">0301&mdash;&mdash;Notification 通知</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z2xdx9.html">80C51学习 流水灯</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyrn4e9.html">从MVC到Ajax再到前后端分离的思考</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k62lz9.html">Python用pip安装IPython&sol;Jupyter最佳交互环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyg6mk9.html">MIP 2016年终总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdrkvy9.html">c文件操作整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j46jx8.html">Hexo之傻瓜攻略</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jg265q.html">ACM 第十一届 河南省省赛A题 计划日</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wypvnq.html">SSM的搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rrdl39.html">JS中创建多个相同的变量出现的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll1zeeq.html">Python实现将爱词霸每日一句定时推送至微信</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rdzlm9.html">TJOI2011书架&lpar;dp&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g2kgvq.html">linux中使用pip命令遇到的一些问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kpv3r79.html">【知识整理】这可能是最好的RxJava 2&period;x 入门教程（四）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjyrrj8.html">oracle 树形表结构查询 排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1gw0mq.html">win7休眠的开启与关闭方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjwkpk8.html">phpexcl导出数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp2jl79.html">JavaScript从入门到忘记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjwnxx8.html">MQ队列管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pdmmv8.html">DOM元素拖拽效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdgk7d9.html">使用C&num;创建SQLite桌面应用程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkyedj8.html">Maven入门1-在Eclipse中新建Maven Web项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k4j649.html">hihocoder 1050 树中的最长路（动态规划，dfs搜索）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
